/*
 * NotebookHtmlMetadata.java
 *
 * Copyright (C) 2009-16 by RStudio, Inc.
 *
 * Unless you have received this program directly from RStudio pursuant
 * to the terms of a commercial license agreement with RStudio, then
 * this program is licensed to you under the terms of version 3 of the
 * GNU Affero General Public License. This program is distributed WITHOUT
 * ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
 * AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
 *
 */
package org.rstudio.studio.client.rmarkdown.model;

import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.core.client.JsArrayString;

public class NotebookHtmlMetadata extends JavaScriptObject
{
   protected NotebookHtmlMetadata()
   {
   }
   
   public final native JsArrayString getClasses() /*-{
      return this.classes || [];
   }-*/;

   public final native boolean getSizingPolicyKnitrFigure() /*-{
      var defaultFigurePolicy = true;

   	if (!this.sizingPolicy) return defaultFigurePolicy;
   	if (!this.sizingPolicy.knitr) return defaultFigurePolicy;
   	if (typeof(this.sizingPolicy.knitr.figure) === "undefined") return defaultFigurePolicy;
   	if (this.sizingPolicy.knitr.figure === null) return defaultFigurePolicy

   	var figure = this.sizingPolicy.knitr.figure;
      return figure.length ? figure[0] : figure;
   }-*/;
}
