/*
 * TestServerOperations.java
 *
 * Copyright (C) 2009-19 by RStudio, Inc.
 *
 * Unless you have received this program directly from RStudio pursuant
 * to the terms of a commercial license agreement with RStudio, then
 * this program is licensed to you under the terms of version 3 of the
 * GNU Affero General Public License. This program is distributed WITHOUT
 * ANY EXPRESS OR IMPLIED WARRANTY, INCLUDING THOSE OF NON-INFRINGEMENT,
 * MERCHANTABILITY OR FITNESS FOR A PARTICULAR PURPOSE. Please refer to the
 * AGPL (http://www.gnu.org/licenses/agpl-3.0.txt) for more details.
 *
 */
package org.rstudio.studio.client.workbench.views.source.model;

import org.rstudio.studio.client.common.console.ConsoleProcess;
import org.rstudio.studio.client.server.ServerRequestCallback;
import org.rstudio.studio.client.shiny.model.ShinyTestResults;

public interface TestServerOperations
{
   void hasShinyTestDependenciesInstalled(ServerRequestCallback<Boolean> callback);
   
   void installShinyTestDependencies(ServerRequestCallback<ConsoleProcess> callback);

   void hasShinyTestResults(String testFile, ServerRequestCallback<ShinyTestResults> callback);
}
